Files
apfstests/tests/xfs/103
T
Dave Chinner 2529c9486a xfs: convert tests to SPDX license tags
Fully scripted conversion, see script in initial SPDX license commit
message.

tests/xfs/044 was hand massaged to remove duplicate copyright and
divider lines before running the script.

Signed-off-by: Dave Chinner <dchinner@redhat.com>
2018-06-09 11:35:45 +10:00

85 lines
1.8 KiB
Bash
Executable File

#! /bin/bash
# SPDX-License-Identifier: GPL-2.0
# Copyright (c) 2000-2005 Silicon Graphics, Inc. All Rights Reserved.
#
# FS QA Test No. 103
#
# Exercise the XFS nosymlinks inode flag
#
seq=`basename $0`
seqres=$RESULT_DIR/$seq
echo "QA output created by $seq"
here=`pwd`
tmp=/tmp/$$
status=1 # failure is the default!
trap "rm -f $tmp.*; exit \$status" 0 1 2 3 15
# get standard environment, filters and checks
. ./common/rc
. ./common/filter
_create_scratch()
{
echo "*** mkfs"
if ! _scratch_mkfs_xfs >$tmp.out 2>&1
then
cat $tmp.out
echo "failed to mkfs $SCRATCH_DEV"
exit 1
fi
echo "*** mount"
if ! _try_scratch_mount 2>/dev/null
then
echo "failed to mount $SCRATCH_DEV"
exit 1
fi
}
_filter_noymlinks_flag()
{
_test_inode_flag nosymlinks $SCRATCH_MNT/nosymlink
if [ $? -eq 0 ]; then
echo "--n-- SCRATCH_MNT/nosymlink"
else
echo "----- SCRATCH_MNT/nosymlink"
fi
}
# real QA test starts here
_supported_os Linux
_supported_fs xfs
_require_scratch
_create_scratch
echo "*** testing nosymlinks directories"
mkdir $SCRATCH_MNT/nosymlink
echo "*** setting nosymlinks bit"
$XFS_IO_PROG -r -c 'chattr +n' $SCRATCH_MNT/nosymlink
_filter_noymlinks_flag
touch $SCRATCH_MNT/nosymlink/source
ln -s $SCRATCH_MNT/nosymlink/source $SCRATCH_MNT/nosymlink/target 2>&1 \
| _filter_scratch | _filter_ln
ln $SCRATCH_MNT/nosymlink/source $SCRATCH_MNT/nosymlink/hardlinksareok
echo "*** 1st listing..."
find $SCRATCH_MNT | _filter_scratch
echo "*** clearing nosymlinks bit"
$XFS_IO_PROG -r -c 'chattr -n' $SCRATCH_MNT/nosymlink
_filter_noymlinks_flag
ln -s $SCRATCH_MNT/nosymlink/source $SCRATCH_MNT/nosymlink/target
ln $SCRATCH_MNT/nosymlink/source $SCRATCH_MNT/nosymlink/hardlinksareok2
echo "*** 2nd listing..."
find $SCRATCH_MNT | _filter_scratch
echo "*** finished testing nosymlinks directories"
status=0
exit